package conecta4;

import conecta4.tablero.Posicion;

public abstract class Player {
	protected boolean thinking;
	protected int move;
	
	public Player() {
		thinking = false;
		move = -1;
	}
	
	
	public void think(Posicion posicion) {
		thinking = true;
		startThinking(posicion);
	}
	
	
	public int getMove() {
		if (thinking) { return -1; };
		return move;
	}
	
	
	protected void startThinking(Posicion posicion) { };
	
	
	public boolean isThinking() {
		return thinking;
	}
}
