package conecta4.tablero;

import conecta4.Constantes;

public class Posicion {
	private Valor turno;
	Valor[][] tablero;
	private int lastFila;
	private EvaluadorPosicion evaluador;
	
	public Posicion() {
		turno = Valor.PLAYER1;
		tablero = new Valor[Constantes.FILAS_TABLERO][Constantes.COLUMNAS_TABLERO];
		for (int fila = 0; fila < Constantes.FILAS_TABLERO; fila++) {
			for (int col = 0; col < Constantes.COLUMNAS_TABLERO; col++) {
				tablero[fila][col] = Valor.NONE;
			}
		}
		evaluador = new EvaluadorPosicion(this);
	}
	
	
	public Valor getTurno() {
		return turno;
	}
	
	
	public Valor getValor(int fila, int col) {
		return tablero[fila][col];
	}
	
	
	public int getLastFila() {
		return lastFila;
	}
	
	
	public boolean meterFicha(int col) {
		if ((col < 0) || (col >= Constantes.COLUMNAS_TABLERO)) { return false; };
		for (int fila = Constantes.FILAS_TABLERO - 1; fila >= 0; fila--) {
			if (tablero[fila][col] == Valor.NONE) {
				//System.out.println(fila + "," + col);
				tablero[fila][col] = turno;
				turno = (turno == Valor.PLAYER1 ? Valor.PLAYER2 : Valor.PLAYER1);
				lastFila = fila;
				return true;
			}
		}
		return false;
	}
	
	
	public Valor getWinner() {
		return evaluador.getWinner();
	}
	
	
	public boolean isDraw() {
		return evaluador.isDraw();
	}

}
