package window.graficos;

import java.awt.Color;
import java.awt.Graphics;

import conecta4.Constantes;

public class Ficha {
	private Color color;
	private Pos pos;
	private boolean visible;
	private boolean enMovimiento;
	private int y0, y1;
	private int ticks;
	
	public Ficha(Color color) {
		this.color = color;
		pos = new Pos();
		visible = false;
		enMovimiento = false;
	}
	
	public boolean isVisible() { return visible; };
	
	public boolean isEnMovimiento() { return enMovimiento; };
	
	public void desaparece() { enMovimiento = visible = false; };
	
	public int getX() { return pos.getX(); }
	
	public int getY() { return pos.getY(); }
	
	public void caer(int x, int y0, int y1) {
		// La colocamos en posicion de partida
		pos.setX(x); pos.setY(y0);
		enMovimiento = visible = true;
		this.y0 = y0;
		this.y1 = y1;
		ticks = (int) Math.round(-0.2 * Constantes.FPS);
	}
	
	public void draw(Graphics g) {
		if (!visible) { return; };
		g.setColor(color);
		g.fillOval(pos.getX(), pos.getY(), Constantes.DIAMETRO_FICHA, Constantes.DIAMETRO_FICHA);
	}	
	
	public void mover() {
		if (!enMovimiento) { return; };
		ticks++; if (ticks < 0) { return; }; 
		double y = (Constantes.ACELERACION * ticks * ticks / 2.0) + y0;
		pos.setY(y);
		if (pos.getY() >= y1) { pos.setY(y1); enMovimiento = false; };
		
	}
	
}
