package window.graficos;

import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;

import conecta4.Constantes;

public class Numeros {
	private int offsetX, offsetY;
	private Font font;
	private Color color;
	private int selectedMove;
	private boolean turnPlayer1;
	
	public Numeros(int offsetX, int offsetY) {
		this.offsetX = offsetX; this.offsetY = offsetY;
		font = new Font("Default", Font.BOLD, 32);
		color = new Color(50,50,255);
		selectedMove = -1;
		turnPlayer1 = true;
	}
	
	public void draw(Graphics g) {
		g.setFont(font);
		for (int num = 1; num <= Constantes.COLUMNAS_TABLERO; num++) {
			g.setColor(color);
			if (selectedMove == num - 1) {
				g.setColor(turnPlayer1 ? Color.red : Color.yellow); 
			}
			g.drawString(Integer.toString(num), offsetX + (num - 1) * Constantes.DIAMETRO_FICHA, offsetY);
		} 
	}
	
	public void setSelectedMove(int move, boolean player1) {
		selectedMove = move;
		turnPlayer1 = player1;
	}
}
