/*HILO encargado de extablecer la comunicación con otro jugador y
 recibir peticiones por parte del otro jugador para actuar en consecuencia*/
package hundirlaflota;

import java.net.*;
import java.io.*;
import java.util.HashMap;
import javax.swing.JOptionPane;

public class Client extends Thread{
    HashMap tablero;
    Tablero tab;
    String lanzamiento="";
    String buffer;
    String ip;
    Utilities u;
    boolean seguir=true;
    //Constructor que recibo como parametros la ip del jugador a conectarme y la clase principal
    public Client(String ip,Tablero tab){ 
        
        this.ip=ip;
        this.tab=tab;
        u=new Utilities(tab);
        
        
    }
    //metodo que se encarga de la inicialización de la conexion con el otro jugador
    public void conectar(){
        try{
            
            if (! tab.estaConectado){//si no esta conectado con nadie
                //establezco conexion con el otro jugador
                //tab.s=new Socket(ip,8000);
                tab.s=new Socket();
                tab.s.connect(new InetSocketAddress(ip,8000), 2500);
                //creo los flujos por los que intercambiar datos
                tab.oo=new ObjectOutputStream(tab.s.getOutputStream());
                tab.oi=new ObjectInputStream(tab.s.getInputStream());
                //inicializo componentes del interfaz principal
                tab.estaConectado=true;
                tab.getIpConect().setEnabled(false);
                tab.getBotonConectar().setText("Parar");
            }
        }catch(Exception ex){
            showsms("Error al conectar: "+ex.getMessage());
        }
    }
    
    //metodo obligatorio del hilo (hereda de Thread)
    public void run(){
        pedirConexion();//llamo al metodo principal 
    }
    //metodo que lee del socket creado con el servidor del otro jugador y devuelve lo leido
    public String leerinfo(){
        String res="";
        try{
            res=(String)tab.oi.readObject();
            if (res.contains("-")){
                String [] t=res.split("-");
                res=t[0];
                lanzamiento=t[1];
            }
        }catch(Exception ex){
            showsms("Error (cliente) al leer datos "+ex.getMessage());
        }
        return res;
    }
    /*Metodo principal que se encarga de:
        - Llamar al metodo de iniciar conexion
        - Envia la peticion de conexion (codigo 100)
        - Mientras seguir=true lee todo lo que le llegue por el socket y actua en consecuecia*/
    public void pedirConexion(){
        try{
            conectar();
            tab.oo.writeObject("100");
            tab.eb.turno=true;
            while(seguir){
                buffer=leerinfo();
                if (buffer.equals("101")){//confirmacion de conexion
                    showsms("Conectado con "+tab.s.getInetAddress().toString().substring(1));
                    tab.estaConectado=true;
                    tab.getServerLabel().setText(tab.getIpConect().getText());
                    
                }
                else if (buffer.equals("200")){//peticion de cierre
                    if (tab.estaConectado){
                        tab.oo.writeObject("201");
                        tab.setColorTablero();
                        tab.iniTablero();
                        tab.setSelect();
                        tab.getColocar().setEnabled(true);
                        tab.getLimpiar().setEnabled(true);
                        tab.getBotonConectar().setText("Jugar");
                        tab.getIpConect().setText("");
                        tab.getIpConect().setEnabled(true);
                        tab.getServerLabel().setText("Elegir jugador");
                        tab.getListBarcos().setText("- ");
                        tab.estaConectado=false;
                        tab.eb.prohibidos.clear();
                        tab.eb.miflotalista=false;
                        tab.eb.rivalflotalista=false;
                        seguir=false;
                    }
                }
                else if (buffer.equals("201")){//confirmacion de cierre
                    seguir=false;
                }
                else if (buffer.equals("300")){//recibo disparo
                    if (u.actualizoFlota(Integer.parseInt(lanzamiento))){
                        tab.oo.writeObject("301-"+lanzamiento);
                        //compruebo a ver si ha ocurrido
                        String suceso=tab.eb.ocurreSuceso();
                        if (suceso.equals("perdido")){
                            tab.oo.writeObject("500");
                            showsms("Lo siento. Has PERDIDO la partida");
                            //seguir=false;
                        }
                        else if (suceso.equals("PORTAVIONES")){
                            tab.oo.writeObject("501");
                            showsms("Tu "+suceso+" ha sido destruido");
                        }
                        else if (suceso.equals("ACORAZADO")){
                            tab.oo.writeObject("502");
                            showsms("Tu "+suceso+" ha sido destruido");
                        }
                        else if (suceso.equals("DESTRUCTOR 1")){
                            tab.oo.writeObject("503");
                            showsms("Tu "+suceso+" ha sido destruido");
                        }
                        else if (suceso.equals("DESTRUCTOR 2")){
                            tab.oo.writeObject("504");
                            showsms("Tu "+suceso+" ha sido destruido");
                        }
                        else if (suceso.equals("FRAGATA")){
                            tab.oo.writeObject("505");
                            showsms("Tu "+suceso+" ha sido destruida");
                        }
                    }
                    else{
                        tab.oo.writeObject("302-"+lanzamiento);
                    }
                    tab.eb.turno=true;
                    showsms("Tu turno");
                }
                else if (buffer.equals("301")){//Confirmacion de que le he dado
                    u.actualizoFlotaRival(Integer.parseInt(lanzamiento), true);
                }
                else if (buffer.equals("302")){//confirmacion de que NO le he dado
                    u.actualizoFlotaRival(Integer.parseInt(lanzamiento), false);
                }
                else if (buffer.equals("400")){//mi rival esta listo
                    tab.eb.rivalflotalista=true;
                    showsms("Tu rival esta listo para empezar");
                }
                else if (buffer.equals("500")){//confirmacion de que mi rival a ha perdido
                    showsms("ENHORABUENA. Has ganado a tu rival. Eres el rey de los mares");
                    //seguir=false;
                }
                else if (buffer.equals("501")){
                    showsms("PORTAVIONES de tu rival destruido");
                    tab.getListBarcos().setText(tab.getListBarcos().getText()+"PORTAVIONES  ");
                }
                else if (buffer.equals("502")){
                    showsms("ACORAZADO de tu rival destruido");
                    tab.getListBarcos().setText(tab.getListBarcos().getText()+"ACORAZADO  ");
                }
                else if (buffer.equals("503")){
                    showsms("DESTRUCTOR 1 de tu rival destruido");
                    tab.getListBarcos().setText(tab.getListBarcos().getText()+"DESTRUCTOR 1  ");
                }
                else if (buffer.equals("504")){
                    showsms("DESTRUCTOR 2 de tu rival destruido");
                    tab.getListBarcos().setText(tab.getListBarcos().getText()+"DESTRUCTOR 2  ");
                }
                else if (buffer.equals("505")){
                    showsms("FRAGATA de tu rival destruida");
                    tab.getListBarcos().setText(tab.getListBarcos().getText()+"FRAGATA  ");
                }
            }
            //cierro estruturas de conexion
            tab.oo.close();
            tab.oi.close();
            tab.s.close();
        }catch(Exception ex){
            showsms("Error (cliente) al atender servicio: "+ex.getMessage());
            seguir=false;
        }
        
    }
    //saca un mensaje de alerta con un texto especificado
    public void showsms(String sms){
        JOptionPane.showMessageDialog(null, sms);
    }
}
