/*HILO encargado de aceptar la comunicación con otro jugador y
 recibir peticiones por parte del otro jugador para actuar en consecuencia*/
package hundirlaflota;


import java.net.*;
import java.io.*;
import javax.swing.JOptionPane;

public class Server extends Thread{
    ServerSocket ss;
    
    Utilities u;
    String bufstring="";
    String lanzamiento="";
    boolean seguir=true;
    boolean seguirsup=true;
    
    Tablero tab;
    
    //constructor en el que le paso el tablero como parametro
    public Server(Tablero tab){
        this.tab=tab;
        u=new Utilities(this.tab);
    }
    //metodo obligatorio del hilo (hereda de Thread)
    public void run(){
        escuchar();
    }
    //metodo que espera una conexion
    public void escuchar(){
        try{
            
            while(seguirsup){
                ss=new ServerSocket(8000);
                tab.s=ss.accept();//acepta la conexion
                //creo los flujos por los que intercambiar datos
                tab.oi=new ObjectInputStream(tab.s.getInputStream());
                tab.oo=new ObjectOutputStream(tab.s.getOutputStream());
                seguir=true;
                atenderPeticiones();//atiendo peticiones
            }
        }catch(Exception ex){
            showsms("Error (servidor) esperando conexion: "+ex.getMessage());
            seguirsup=false;
        }
    }
    //leo del socket creado con el cliente del otro jugador y devuelve lo leido
    public String leerStringSocket(){
        String res="";
        try{
            res=(String)tab.oi.readObject();
            if (res.contains("-")){
                String [] t=res.split("-");
                res=t[0];
                lanzamiento=t[1];
            }
        }catch(Exception ex){
            System.out.println("Error (servidor) al leer datos: "+ex.getMessage());
        }
        return res;
    }
    //metodo que atiende las peticiones que le llegan por el socket y actua en consecuencia
    public void atenderPeticiones(){
        try{
            while(seguir){
                bufstring=leerStringSocket();
                if (bufstring.equals("100")){//recibo una peticion de conexion para jugar
                    tab.estaConectado=true;
                    tab.eb.turno=false;
                    tab.getIpConect().setText(tab.s.getInetAddress().toString().substring(1));
                    tab.getIpConect().setEnabled(false);
                    tab.getBotonConectar().setText("Parar");
                    //actualizo cartel
                    tab.getServerLabel().setText(tab.s.getInetAddress().toString().substring(1));
                    tab.oo.writeObject("101");
                    showsms("Conectado con "+tab.s.getInetAddress().toString().substring(1));
                    
                }
                else if (bufstring.equals("200")){//terminar de jugar
                   if (tab.estaConectado){
                        tab.oo.writeObject("201");
                        tab.setColorTablero();
                        tab.iniTablero();
                        tab.setSelect();
                        tab.getColocar().setEnabled(true);
                        tab.getLimpiar().setEnabled(true);
                        tab.getBotonConectar().setText("Jugar");
                        tab.getIpConect().setText("");
                        tab.getIpConect().setEnabled(true);
                        tab.getServerLabel().setText("Elegir jugador");
                        tab.getListBarcos().setText("- ");
                        tab.eb.prohibidos.clear();
                        tab.estaConectado=false;
                        tab.eb.miflotalista=false;
                        tab.eb.rivalflotalista=false;
                        seguir=false;
                   }
                }
                else if (bufstring.equals("201")){//confirmacion de cierr
                    seguir=false;
                }
                else if(bufstring.equals("300")){//Disparo del rival
                    if (u.actualizoFlota(Integer.parseInt(lanzamiento))){
                        tab.oo.writeObject("301-"+lanzamiento);
                        String suceso=tab.eb.ocurreSuceso();
                        if (suceso.equals("perdido")){
                            tab.oo.writeObject("500");
                            showsms("Lo siento. Has PERDIDO la partida");
                            //seguir=false;
                        }
                        else if (suceso.equals("PORTAVIONES")){
                            tab.oo.writeObject("501");
                            showsms("Tu "+suceso+" ha sido destruido");
                        }
                        else if (suceso.equals("ACORAZADO")){
                            tab.oo.writeObject("502");
                            showsms("Tu "+suceso+" ha sido destruido");
                        }
                        else if (suceso.equals("DESTRUCTOR 1")){
                            tab.oo.writeObject("503");
                            showsms("Tu "+suceso+" ha sido destruido");
                        }
                        else if (suceso.equals("DESTRUCTOR 2")){
                            tab.oo.writeObject("504");
                            showsms("Tu "+suceso+" ha sido destruido");
                        }
                        else if (suceso.equals("FRAGATA")){
                            tab.oo.writeObject("505");
                            showsms("Tu "+suceso+" ha sido destruida");
                        }
                    }
                    else{
                        tab.oo.writeObject("302-"+lanzamiento);
                    }
                    //cambio de turno
                    tab.eb.turno=true;
                    showsms("Tu turno");
                }
                else if (bufstring.equals("301")){//Confirmacion de que le he dado
                    u.actualizoFlotaRival(Integer.parseInt(lanzamiento), true);
                }
                else if (bufstring.equals("302")){//confirmacion de que NO le he dado
                    u.actualizoFlotaRival(Integer.parseInt(lanzamiento), false);
                }
                
                else if (bufstring.equals("400")){//mi rival esta listo
                    tab.eb.rivalflotalista=true;
                    showsms("Tu rival esta listo para empezar");
                }
                else if (bufstring.equals("500")){
                    showsms("ENHORABUENA. Has ganado a tu rival. Eres el rey de los mares");
                    //seguir=false;
                }
                else if (bufstring.equals("501")){
                    showsms("PORTAVIONES de tu rival destruido");
                    tab.getListBarcos().setText(tab.getListBarcos().getText()+"PORTAVIONES  ");
                }
                else if (bufstring.equals("502")){
                    showsms("ACORAZADO de tu rival destruido");
                    tab.getListBarcos().setText(tab.getListBarcos().getText()+"ACORAZADO  ");
                }
                else if (bufstring.equals("503")){
                    showsms("DESTRUCTOR 1 de tu rival destruido");
                    tab.getListBarcos().setText(tab.getListBarcos().getText()+"DESTRUCTOR 1  ");
                }
                else if (bufstring.equals("504")){
                    showsms("DESTRUCTOR 2 de tu rival destruido");
                    tab.getListBarcos().setText(tab.getListBarcos().getText()+"DESTRUCTOR 2  ");
                }
                else if (bufstring.equals("505")){
                    showsms("FRAGATA de tu rival destruida");
                    tab.getListBarcos().setText(tab.getListBarcos().getText()+"FRAGATA  ");
                }
                
            }
            //cierro conexion con el cliente del otro jugador
            tab.oo.close();
            tab.oi.close();
            ss.close();
            tab.s.close();
            tab.s=null;
            
        }catch(Exception ex){
            showsms("Error (servidor) al atender servicio: "+ex.getMessage());
            seguir=false;
        }
        
    }
    //saca un mensaje de alerta con un texto especificado
    public void showsms(String sms){
        JOptionPane.showMessageDialog(null, sms);
    }
    
    
}
