//clase con un API de funciones
package hundirlaflota;

import java.awt.Color;
import java.net.InetAddress;
import java.net.NetworkInterface;
import java.util.Enumeration;
import javax.swing.JOptionPane;


public class Utilities {
    //paso la clase principal como argumento
    Tablero tab;
    public Utilities(Tablero tab){
        this.tab=tab;
    }
    
    //metodo que me devuelve la IP privada de la red a la que estoy conectado
    public static String getIp(){
        String ip="",ipaux="";
        try{
            for (Enumeration<NetworkInterface> en = NetworkInterface.getNetworkInterfaces(); en.hasMoreElements();) {
                NetworkInterface intf = en.nextElement();
                
                for (Enumeration<InetAddress> enumIpAddr = intf.getInetAddresses(); enumIpAddr.hasMoreElements();) {
                    InetAddress inetAddress = enumIpAddr.nextElement();
                    ipaux=inetAddress.toString();
                    if ((! ipaux.substring(1, 4).equals("127")) && (ipaux.substring(1, 2).equals("1"))){
                        ip=ipaux.substring(1);
                    }
                }
            }
        }catch(Exception ex){
            
        }
        return ip;
    }
    //metodo con el que comunico al otro usuario que he terminado de colocar mi flota
    public void estoyListo(){
        try{
            if (tab.estaConectado){//debe cumplir que este conectado a otro jugador
                tab.oo.writeObject("400");
                tab.oo.flush();
                tab.eb.miflotalista=true;
            }
        }catch(Exception ex){}
    }
    //metodo con el que simulo lanzar un cohete a mi rival en la coordenada (un entero) pasada como parametro
    public void lanzarCohete(int id){
        if (tab.eb.miflotalista){//debe cumplir que mi flota este colocada
            if (tab.eb.rivalflotalista){//debe cumplir que la flota de mi rival este colocada
                if (tab.eb.turno){//debe ser mi turno
                    try{
                        tab.oo.writeObject("300-"+id);
                        tab.oo.flush();
                        tab.eb.turno=false;
                    }catch(Exception ex){

                    }
                    
                }
                else{
                    showsms("No es tu turno");
                }
            }
            else{
                showsms("El rival no ha colocado su flota");
            }
        }
        else{
            showsms("No has colocado toda tu flota");
        }
    }
    //metodo que me devuelve si el cohete que me han lanzado en la posicion
    //pasada como parametro ha impactado o no en algún barco de mi flota
    public boolean haImpactado(int id){
        boolean res=false;
        Barco bar;
        bar=(Barco)tab.eb.flota.get("Portaviones (5)");
        if (bar.tocado(id)){
            res=true;
        }
        tab.eb.flota.put("Portaviones (5)", bar);
        bar=(Barco)tab.eb.flota.get("Acorazado (4)");
        if (bar.tocado(id)){
            res=true;
        }
        tab.eb.flota.put("Acorazado (4)", bar);
        bar=(Barco)tab.eb.flota.get("Destructor 1 (3)");
        if (bar.tocado(id)){
            res=true;
        }
        tab.eb.flota.put("Destructor 1 (3)", bar);
        bar=(Barco)tab.eb.flota.get("Destructor 2 (3)");
        if (bar.tocado(id)){
            res=true;
        }
        tab.eb.flota.put("Destructor 2 (3)", bar);
        bar=(Barco)tab.eb.flota.get("Fragata (2)");
        if (bar.tocado(id)){
            res=true;
        }
        tab.eb.flota.put("Fragata (2)", bar);
        return res;
    }
    //metodo que me actualiza el tablero de MI RIVAL según haya sido tocado o no
    public void actualizoFlotaRival(int id,boolean res){
        Posicion pos=(Posicion) tab.tableror.get(id);
        
        if (res){
            pos.getBoton().setBackground(Color.red);
        }
        else{
            
            pos.getBoton().setBackground(Color.blue);
        }
        tab.tableror.put(id, pos);//no hacia falta. Mismo caso que antes
    }
    //metodo que me actualiza el tablero de MI FLOTA según haya sido tocado o no
    public boolean actualizoFlota(int id){
        boolean b=false;
        Posicion pos=(Posicion) tab.tablero.get(id);
        if (haImpactado(id)){
            pos.getBoton().setBackground(Color.red);
            b=true;
        }
        else{
            pos.getBoton().setBackground(Color.blue);
        }
        tab.tablero.put(id, pos);//no es necesario. Se modica el puntero.
        return b;
    }
    //metodo que me devuelve si las coordenadas de un barco que quiero colocar pertenecen
    //o no a un perímetro prohivido de otro barco
    public boolean esPerimetro(int [] datos){
        boolean res=false;
        for (int i=0;i<datos.length;i++){
            String d=datos[i]+"";
            if (tab.eb.prohibidos.contains(d)){
                res=true;
            }
        }
        return res;
    }
    //metodo que me devuelve si al colocar un barco el usuario se ha podido equivocar 
    //por el hecho de que aparezca en dos filas o columnas distintas (partido)
    public boolean barcoPartido(int inicio,String barco,boolean posicion){
        try{
            boolean res=false;
            if (posicion){//vertical   
                if (barco.equals("Portaviones (5)")){
                    if (inicio>=61){
                        res=true;
                    }
                }
                else if (barco.equals("Acorazado (4)")){
                    if (inicio>=71){
                        res=true;
                    }
                }
                else if (barco.equals("Destructor 1 (3)")){
                    if (inicio>=81){
                        res=true;
                    }
                }
                else if (barco.equals("Destructor 2 (3)")){
                    if (inicio>=81){
                        res=true;
                    }
                }
                else if (barco.equals("Fragata (2)")){
                    if (inicio>=91){
                        res=true;
                    }
                }
            }
            else{//horizontal
                
                if (barco.equals("Portaviones (5)")){
                    if (((inicio>=7) && (inicio<=10)) || ((inicio>=17) && (inicio<=20)) || ((inicio>=27) && (inicio<=30)) || ((inicio>=37) && (inicio<=40)) || ((inicio>=47) && (inicio<=50)) || 
                            ((inicio>=57) && (inicio<=60)) || ((inicio>=67) && (inicio<=70)) || ((inicio>=77) && (inicio<=80)) || ((inicio>=87) && (inicio<=90)) || ((inicio>=97) && (inicio<=100))){
                        res=true;
                    }


                }
                else if (barco.equals("Acorazado (4)")){
                    if (((inicio>=8) && (inicio<=10)) || ((inicio>=18) && (inicio<=20)) || ((inicio>=28) && (inicio<=30)) || ((inicio>=38) && (inicio<=40)) || ((inicio>=48) && (inicio<=50)) || 
                            ((inicio>=58) && (inicio<=60)) || ((inicio>=68) && (inicio<=70)) || ((inicio>=78) && (inicio<=80)) || ((inicio>=88) && (inicio<=90)) || ((inicio>=98) && (inicio<=100))){
                        res=true;
                    }
                }
                else if (barco.equals("Destructor 1 (3)")){
                    if (((inicio>=9) && (inicio<=10)) || ((inicio>=19) && (inicio<=20)) || ((inicio>=29) && (inicio<=30)) || ((inicio>=39) && (inicio<=40)) || ((inicio>=49) && (inicio<=50)) || 
                            ((inicio>=59) && (inicio<=60)) || ((inicio>=69) && (inicio<=70)) || ((inicio>=79) && (inicio<=80)) || ((inicio>=89) && (inicio<=90)) || ((inicio>=99) && (inicio<=100))){
                        res=true;
                    }
                }
                else if (barco.equals("Destructor 2 (3)")){
                    if (((inicio>=9) && (inicio<=10)) || ((inicio>=19) && (inicio<=20)) || ((inicio>=29) && (inicio<=30)) || ((inicio>=39) && (inicio<=40)) || ((inicio>=49) && (inicio<=50)) || 
                            ((inicio>=59) && (inicio<=60)) || ((inicio>=69) && (inicio<=70)) || ((inicio>=79) && (inicio<=80)) || ((inicio>=89) && (inicio<=90)) || ((inicio>=99) && (inicio<=100))){
                        res=true;
                    }
                }
                else if (barco.equals("Fragata (2)")){
                    if ((inicio==10) || (inicio==20) || (inicio==30) || (inicio==40) || (inicio==50) || 
                            (inicio==60) || (inicio==70) || (inicio==80) || (inicio==90) || (inicio==100)){
                        res=true;
                    }
                }
            }
            return res;
        }catch(Exception ex){
            System.out.println("Exception en barco partido: "+ex.getMessage());
            return true;
        }
    }
    //cierra la conexión con el otro jugador
    public void cerrar(){
        try{
            if (tab.estaConectado){
                tab.oo.writeObject("200");
            }
        }catch(Exception ex){
            showsms("Error al cerrar partida: "+ex.getMessage());
        }
    }
    //saca un mensaje de alerta con un texto especificado
    public void showsms(String sms){
        JOptionPane.showMessageDialog(null, sms);
    }
}
